"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Convert vega-lite to vega first, then render to svg.
 */
const YAML = __importStar(require("yamljs"));
const utility = __importStar(require("./utility"));
const vega = __importStar(require("./vega"));
let vl = null;
function toSVG(spec = "", baseURL = "") {
    return __awaiter(this, void 0, void 0, function* () {
        if (!vl) {
            vl = utility.loadDependency("vega-lite/vega-lite.min.js");
        }
        spec = spec.trim();
        let d;
        if (spec[0] !== "{") {
            d = YAML.parse(spec);
        }
        else {
            // json
            d = JSON.parse(spec);
        }
        return utility.allowUnsafeEval(() => {
            return utility.allowUnsafeNewFunction(() => {
                return vega.toSVG(JSON.stringify(vl.compile(d).spec), baseURL);
            });
        });
    });
}
exports.toSVG = toSVG;
//# sourceMappingURL=vega-lite.js.map